// BonTuner.cpp: CBonTuner NX̃Cve[V
//
// ^Cv`[i[ւ̑Ή͏̂
//////////////////////////////////////////////////////////////////////

#include <Windows.h>
#include <SetupApi.h>
#include <Malloc.h>
#include <InitGuid.h>
#include <Math.h>
#include "Resource.h"
#include "BonTuner.h"


#pragma comment(lib, "SetupApi.lib")


//////////////////////////////////////////////////////////////////////
// 萔`
//////////////////////////////////////////////////////////////////////

// ݂͂ǂ炩݂̂g(̂p~邩)
#define BONDRIVER_TYPE_WHITE
//#define BONDRIVER_TYPE_BLACK

// ~[ebNX
#ifdef BONDRIVER_TYPE_WHITE
#define MUTEX_NAME			TEXT("BonDriver_Shiro")
#endif
#ifdef BONDRIVER_TYPE_BLACK
#define MUTEX_NAME			TEXT("BonDriver_Kuro")
#endif

// MTCY
#define TSDATASIZE			48128			// TSf[^̃TCY

// FIFOobt@ݒ
#define ASYNCBUFFTIME		2											// obt@ = 2b
#define ASYNCBUFFSIZE		( 0x200000 / TSDATASIZE * ASYNCBUFFTIME )	// 16MbpsƂ

#define REQRESERVNUM		16				// 񓯊NGXg\
#define REQPOLLINGWAIT		10				// 񓯊NGXg|[OԊu(ms)

// 񓯊NGXg
#define IORS_IDLE			0x00			// NGXg
#define IORS_BUSY			0x01			// NGXgM	
#define IORS_RECV			0x02			// MAXgA҂

// hCoCX^XGUID(ƂɓĂ̂͂Ȃ񂾂˂c)
DEFINE_GUID( GUID_FRIIO_DRIVER,	0x5a56d255L, 0xe23a, 0x4b4d, 0x8c, 0x78, 0xc2, 0x65, 0x93, 0x0b, 0x6c, 0x68 );


//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

#pragma warning( disable : 4273 )

extern "C" __declspec(dllexport) IBonDriver * CreateBonDriver()
{
	// X^X(̏ꍇ̓CX^X̃|C^Ԃ)
	return (CBonTuner::m_pThis)? CBonTuner::m_pThis : ((IBonDriver *) new CBonTuner);
}

#pragma warning( default : 4273 )


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// ÓIo
CBonTuner * CBonTuner::m_pThis = NULL;
HINSTANCE CBonTuner::m_hModule = NULL;

CBonTuner::CBonTuner()
	: m_hMutex(NULL)
	, m_pIoReqBuff(NULL)
	, m_pIoPushReq(NULL)
	, m_pIoPopReq(NULL)
	, m_hPushIoThread(NULL)
	, m_hPopIoThread(NULL)
	, m_hOnStreamEvent(NULL)
	, m_dwCurSpace(0UL)
	, m_dwCurChannel(0UL)
{
	m_pThis = this;

	// o
	m_hDevice = INVALID_HANDLE_VALUE;

	// NeBJZNV
	::InitializeCriticalSection(&m_CriticalSection);
}

CBonTuner::~CBonTuner()
{
	// JĂꍇ͕
	CloseTuner();

	// NeBJZNV폜
	::DeleteCriticalSection(&m_CriticalSection);

	m_pThis = NULL;
}

const BOOL CBonTuner::OpenTuner()
{
	// UN[Y
	CloseTuner();

	// ̃vZXŃ`[iJĂ邩
	if(IsTunerOpening())return FALSE;

	// obt@m
	if(!(m_pIoReqBuff = AllocIoReqBuff(ASYNCBUFFSIZE))){
		return FALSE;
		}

	// obt@ʒu
	m_pIoPushReq = m_pIoReqBuff;
	m_pIoPopReq = m_pIoReqBuff;
	m_pIoGetReq = m_pIoReqBuff;
	m_dwBusyReqNum = 0;
	m_dwReadyReqNum = 0;

	try{
#ifdef BONDRIVER_TYPE_WHITE
		// hCoI[v(ōŏɂ݂)
		m_hDevice = FindFriioDriver(FALSE,0);
#endif
#ifdef BONDRIVER_TYPE_BLACK
		// hCoI[v(ōŏɂ݂)
		m_hDevice = FindFriioDriver(TRUE,0);
#endif
		if(m_hDevice == INVALID_HANDLE_VALUE)throw 0UL;

#ifdef BONDRIVER_TYPE_WHITE
		// ȊO݂ĂG[
		if(m_iBonType!=BONTYPE_WHITE)throw 99UL;
#endif
#ifdef BONDRIVER_TYPE_BLACK
		// ȊO݂ĂG[
		if(m_iBonType!=BONTYPE_BLACK)throw 99UL;
#endif

		// Œ菉f[^M
		if(!UsbInitalize(m_hDevice)) throw 1UL;

		// ftHg`lݒ
		if(!SetChannel(0UL, 0UL))throw 2UL;

		// Cxg쐬
		if(!(m_hOnStreamEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL)))throw 2UL;

		// XbhN
		DWORD dwPushIoThreadID = 0UL, dwPopIoThreadID = 0UL;
		m_hPushIoThread = ::CreateThread(NULL, 0UL, CBonTuner::PushIoThread, this, CREATE_SUSPENDED, &dwPopIoThreadID);
		m_hPopIoThread = ::CreateThread(NULL, 0UL, CBonTuner::PopIoThread, this, CREATE_SUSPENDED, &dwPushIoThreadID);

		if(!m_hPushIoThread || !m_hPopIoThread){
			if(m_hPushIoThread){
				::TerminateThread(m_hPushIoThread, 0UL);
				::CloseHandle(m_hPushIoThread);
				m_hPushIoThread = NULL;
				}

			if(m_hPopIoThread){
				::TerminateThread(m_hPopIoThread, 0UL);
				::CloseHandle(m_hPopIoThread);
				m_hPopIoThread = NULL;
				}

			throw 3UL;
			}

		// XbhJn
		m_bLoopIoThread = TRUE;
		if(::ResumeThread(m_hPushIoThread) == 0xFFFFFFFFUL || ::ResumeThread(m_hPopIoThread) == 0xFFFFFFFFUL)throw 4UL;

		// ~[ebNX쐬
		if(!(m_hMutex = ::CreateMutex(NULL, TRUE, MUTEX_NAME)))throw 5UL;
		}
	catch(const DWORD dwErrorStep){
		// G[
		TCHAR szDebugOut[1024];
#ifdef BONDRIVER_TYPE_WHITE
		::wsprintf(szDebugOut, TEXT("BonDriver_Shiro: CBonTuner::OpenTuner() dwErrorStep = %lu\n"), dwErrorStep);
#endif
#ifdef BONDRIVER_TYPE_BLACK
		::wsprintf(szDebugOut, TEXT("BonDriver_Kuro: CBonTuner::OpenTuner() dwErrorStep = %lu\n"), dwErrorStep);
#endif
		::OutputDebugString(szDebugOut);

		CloseTuner();
		return FALSE;
		}

	return TRUE;
}

void CBonTuner::CloseTuner()
{
	// XbhIvZbg
	m_bLoopIoThread = FALSE;

	// CxgJ
	::CloseHandle(m_hOnStreamEvent);
	m_hOnStreamEvent = NULL;	

	// XbhI
	if(m_hPushIoThread){
		if(::WaitForSingleObject(m_hPushIoThread, 1000) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPushIoThread, 0);
			::OutputDebugString(TEXT("BonDriver: CBonTuner::CloseTuner() ::TerminateThread(m_hPushIoThread)\n"));
			}		

		::CloseHandle(m_hPushIoThread);
		m_hPushIoThread = NULL;
		}

	if(m_hPopIoThread){
		if(::WaitForSingleObject(m_hPopIoThread, 1000) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPopIoThread, 0);
			::OutputDebugString(TEXT("BonDriver: CBonTuner::CloseTuner() ::TerminateThread(m_hPopIoThread)\n"));
			}		

		::CloseHandle(m_hPopIoThread);
		m_hPopIoThread = NULL;
		}


	// obt@J
	FreeIoReqBuff(m_pIoReqBuff);
	m_pIoReqBuff = NULL;
	m_pIoPushReq = NULL;
	m_pIoPopReq = NULL;
	m_pIoGetReq = NULL;

	// IŒf[^M
	UsbTerminate(m_hDevice);

	// hCoN[Y
	if(m_hDevice != INVALID_HANDLE_VALUE){
		::CloseHandle(m_hDevice);
		m_hDevice = INVALID_HANDLE_VALUE;
		}

	// `l
	m_dwCurChannel = 0UL;
	
	// ~[ebNXJ
	if(m_hMutex){
		::ReleaseMutex(m_hMutex);
		::CloseHandle(m_hMutex);
		m_hMutex = NULL;
		}
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
	// I`FbN
	if(!m_hOnStreamEvent || !m_bLoopIoThread)return WAIT_ABANDONED;

	// CxgVOiԂɂȂ̂҂
	const DWORD dwRet = ::WaitForSingleObject(m_hOnStreamEvent, (dwTimeOut)? dwTimeOut : INFINITE);

	switch(dwRet){
		case WAIT_ABANDONED :
			// `[iꂽ
			return WAIT_ABANDONED;

		case WAIT_OBJECT_0 :
		case WAIT_TIMEOUT :
			// Xg[擾\ or `[iꂽ
			return (m_bLoopIoThread)? dwRet : WAIT_ABANDONED;

		case WAIT_FAILED :
		default:
			// O
			return WAIT_FAILED;
		}
}

const DWORD CBonTuner::GetReadyCount()
{
	// o\TSf[^擾
	return m_dwReadyReqNum;
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	BYTE *pSrc = NULL;

	// TSf[^obt@o
	if(GetTsStream(&pSrc, pdwSize, pdwRemain)){
		if(*pdwSize){
			::CopyMemory(pDst, pSrc, *pdwSize);
			}
		
		return TRUE;
		}
	
	return FALSE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	if(!m_pIoGetReq)return FALSE;

	// TSf[^obt@o
	if(m_dwReadyReqNum){
		if(m_pIoGetReq->dwState == IORS_RECV){

			// f[^Rs[
			*pdwSize = m_pIoGetReq->dwRxdSize;
			*ppDst = m_pIoGetReq->RxdBuff;

			// obt@ʒui߂
			::EnterCriticalSection(&m_CriticalSection);
			m_pIoGetReq = m_pIoGetReq->pNext;
			m_dwReadyReqNum--;
			*pdwRemain = m_dwReadyReqNum;
			::LeaveCriticalSection(&m_CriticalSection);

			return TRUE;
			}
		else{
			// O
			return FALSE;
			}
		}
	else{
		// o\ȃf[^Ȃ
		*pdwSize = 0;
		*pdwRemain = 0;

		return TRUE;
		}
}

void CBonTuner::PurgeTsStream()
{
	// obt@o\f[^p[W

	::EnterCriticalSection(&m_CriticalSection);
	m_pIoGetReq = m_pIoPopReq;
	m_dwReadyReqNum = 0;
	::LeaveCriticalSection(&m_CriticalSection);
}

void CBonTuner::Release()
{
	// CX^XJ
	delete this;
}

LPCTSTR CBonTuner::GetTunerName(void)
{
	// `[iԂ
#ifdef BONDRIVER_TYPE_WHITE
	return TEXT("(ISDB-T)");
#endif
#ifdef BONDRIVER_TYPE_BLACK
	return TEXT("(ISDB-S)");
#endif
}

const BOOL CBonTuner::IsTunerOpening(void)
{
	// `[i̎gp̗LԂ(SvZXʂ)
	HANDLE hMutex = ::OpenMutex(MUTEX_ALL_ACCESS, FALSE, MUTEX_NAME);
	
	if(hMutex){
		// Ƀ`[i͊JĂ
		::CloseHandle(hMutex);
		return TRUE;
		}
	else{
		// `[i͊JĂȂ
		return FALSE;
		}
}

LPCTSTR CBonTuner::EnumTuningSpace(const DWORD dwSpace)
{
	// gp\ȃ`[jOԂԂ
#ifdef BONDRIVER_TYPE_WHITE
	switch(dwSpace){
		case 0UL :	return TEXT("nD");
		default  :	return NULL;		
		}
#endif
#ifdef BONDRIVER_TYPE_BLACK
	switch(dwSpace){
		case 0UL :	return TEXT("BS");
		case 1UL :	return TEXT("110CS");
		default  :	return NULL;		
		}
#endif
}

LPCTSTR CBonTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	// gp\ȃ`lԂ
#ifdef BONDRIVER_TYPE_WHITE
	if(dwSpace || (dwChannel > 62UL))return NULL;
	// nD
	static const TCHAR aszChannelName[][16] = 
	{
		TEXT("13ch"), TEXT("14ch"), TEXT("15ch"), TEXT("16ch"), TEXT("17ch"), TEXT("18ch"), TEXT("19ch"),
		TEXT("20ch"), TEXT("21ch"), TEXT("22ch"), TEXT("23ch"), TEXT("24ch"), TEXT("25ch"), TEXT("26ch"), TEXT("27ch"), TEXT("28ch"), TEXT("29ch"),
		TEXT("30ch"), TEXT("31ch"), TEXT("32ch"), TEXT("33ch"), TEXT("34ch"), TEXT("35ch"), TEXT("36ch"), TEXT("37ch"), TEXT("38ch"), TEXT("39ch"), 
		TEXT("40ch"), TEXT("41ch"), TEXT("42ch"), TEXT("43ch"), TEXT("44ch"), TEXT("45ch"), TEXT("46ch"), TEXT("47ch"), TEXT("48ch"), TEXT("49ch"), 
		TEXT("50ch"), TEXT("51ch"), TEXT("52ch"), TEXT("53ch"), TEXT("54ch"), TEXT("55ch"), TEXT("56ch"), TEXT("57ch"), TEXT("58ch"), TEXT("59ch"), 
		TEXT("60ch"), TEXT("61ch"), TEXT("62ch")
	};
	return aszChannelName[dwChannel];
#endif
#ifdef BONDRIVER_TYPE_BLACK
	switch(dwSpace){
		case 0UL :
			// BS-D
			switch(dwChannel){
				case 0UL :	return TEXT("BS1/TS0 BS");
				case 1UL :	return TEXT("BS1/TS1 BS-i");
				case 2UL :	return TEXT("BS3/TS0 WOWOW");
				case 3UL :	return TEXT("BS3/TS1 BSWp");
				case 4UL :	return TEXT("BS9/TS0 BS11");
				case 5UL :	return TEXT("BS9/TS1 Star Channel HV");
				case 6UL :	return TEXT("BS9/TS2 TwellV");
				case 7UL :	return TEXT("BS13/TS0 BSe");
				case 8UL :	return TEXT("BS13/TS1 BStW");
				case 9UL :	return TEXT("BS15/TS1 NHK BS1/2");
				case 10UL :	return TEXT("BS15/TS2 NHK BS-hi");
				}
	
			return NULL;
		
		case 1UL :
			// 110CS
			switch(dwChannel){
				case 0UL :	return TEXT("ND2 110CS #1");
				case 1UL :	return TEXT("ND4 110CS #2");
				case 2UL :	return TEXT("ND6 110CS #3");
				case 3UL :	return TEXT("ND8 110CS #4");
				case 4UL :	return TEXT("ND10 110CS #5");
				case 5UL :	return TEXT("ND12 110CS #6");
				case 6UL :	return TEXT("ND14 110CS #7");
				case 7UL :	return TEXT("ND16 110CS #8");
				case 8UL :	return TEXT("ND18 110CS #9");
				case 9UL :	return TEXT("ND20 110CS #10");
				case 10UL :	return TEXT("ND22 110CS #11");
				case 11UL :	return TEXT("ND24 110CS #12");
				}
		
			return NULL;
		
		default  :
			// Ή̃`[jO
			return NULL;
		}
#endif
}

const DWORD CBonTuner::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return m_dwCurSpace;
}

const DWORD CBonTuner::GetCurChannel(void)
{
	// ݂̃`lԂ
	return m_dwCurChannel;
}

const HANDLE CBonTuner::FindFriioDriver(const BOOL bSatellite,const BYTE byDeviceIndex)
{
	// ړIFriiohCoĊJ(byDeviceIndex=0͔̐ʃJEg)
	TCHAR szDeviceName[_MAX_PATH];
	BYTE byDeviceCount_White=0;
	BYTE byDeviceCount_Black=0;
	
	for(DWORD dwIndex = 0UL ; GetDriverPath((GUID *)&GUID_FRIIO_DRIVER, szDeviceName, dwIndex) ; dwIndex++){
		// hCoI[v
		if((m_hDevice = ::CreateFile(szDeviceName, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL)) == INVALID_HANDLE_VALUE)continue;
		int iBonType = BONTYPE_UNKNOWN;
		
		// ċ𒲂ׂ
		if(UsbProcFixInitA(m_hDevice,&iBonType)){
			switch(iBonType){
				case BONTYPE_WHITE:{
					byDeviceCount_White++;
#ifdef BONDRIVER_TYPE_WHITE
					if(!bSatellite && (byDeviceIndex+1)==byDeviceCount_White) return m_hDevice;					
#endif
					}
					break;
				case BONTYPE_BLACK:{
					byDeviceCount_Black++;
#ifdef BONDRIVER_TYPE_BLACK
					if(bSatellite && (byDeviceIndex+1)==byDeviceCount_Black) return m_hDevice;					
#endif
					}
					break;
				}
			}

		::CloseHandle(m_hDevice);
		m_hDevice = INVALID_HANDLE_VALUE;
		}

	return INVALID_HANDLE_VALUE;
}

const BOOL CBonTuner::GetDriverPath(GUID *pGuid, LPTSTR lpszPath, const DWORD dwDeviceIndex)
{
	// GUIDfoCX̃pX擾

	// foCXZbg̃nh擾
	HDEVINFO hDevInfo = ::SetupDiGetClassDevs(pGuid, 0UL, NULL, DIGCF_PRESENT | DIGCF_INTERFACEDEVICE);
	if(hDevInfo == INVALID_HANDLE_VALUE)return FALSE;

	// foCXC^tF[X
	SP_DEVICE_INTERFACE_DATA DeviceInterfaceData;
	DeviceInterfaceData.cbSize = sizeof(DeviceInterfaceData);
	if(!::SetupDiEnumDeviceInterfaces(hDevInfo, NULL, pGuid, dwDeviceIndex, &DeviceInterfaceData)){
		::SetupDiDestroyDeviceInfoList(hDevInfo);
		return FALSE;
		}

	// foCXC^tF[X̏ڍׂi[̂ɕKvȃobt@TCY擾
	DWORD dwBuffLen = 0UL;
	::SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, NULL, 0, &dwBuffLen, NULL);

	// obt@m
	dwBuffLen += sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA) + 1;
	SP_DEVICE_INTERFACE_DETAIL_DATA *pDeviceInterfaceDetailData = (SP_DEVICE_INTERFACE_DETAIL_DATA *)_alloca(dwBuffLen);
	pDeviceInterfaceDetailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

	// foCX̃pX擾
	if(!::SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, pDeviceInterfaceDetailData, dwBuffLen, NULL, NULL)){
		::SetupDiDestroyDeviceInfoList(hDevInfo);
		return FALSE;
		}

	// foCXZbg̃nhJ
	::SetupDiDestroyDeviceInfoList(hDevInfo);

	// foCX̃pXRs[
	lstrcpy(lpszPath, pDeviceInterfaceDetailData->DevicePath);

	return TRUE;
}

const int CBonTuner::SendIoRequest(HANDLE hDevice,const DWORD dwIoCode, const BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize)
{
	// I[v`FbN
	if(hDevice == INVALID_HANDLE_VALUE)return -1;

	// Mpf[^ݒ
	OVERLAPPED OverLapped;
	::ZeroMemory(&OverLapped, sizeof(OverLapped));
	if(!(OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return -1;

	// f[^M
	DWORD dwReturned = 0;
	const BOOL bRet = ::DeviceIoControl(hDevice, dwIoCode, (LPVOID)pTxdData, dwTxdSize, pRxdData, dwRxdSize, &dwReturned, &OverLapped);
	
	// Cxg폜
	::CloseHandle(OverLapped.hEvent);

	// G[AMf[^擾
	if(!bRet){
		if(::GetLastError() != ERROR_IO_PENDING)return -1;
		if(!::GetOverlappedResult(hDevice, &OverLapped, &dwReturned, TRUE))return -1;
		}

	return (int)dwReturned;
}

CBonTuner::AsyncIoReq * CBonTuner::AllocIoReqBuff(const DWORD dwBuffNum)
{
	if(dwBuffNum < 2)return NULL;

	// mۂ
	AsyncIoReq *pNewBuff = new AsyncIoReq [dwBuffNum];
	if(!pNewBuff)return NULL;

	// [NA
	::ZeroMemory(pNewBuff, sizeof(AsyncIoReq) * dwBuffNum);

	// N\z
	DWORD dwIndex;
	for(dwIndex = 0 ; dwIndex < ( dwBuffNum - 1 ) ; dwIndex++){
		pNewBuff[dwIndex].pNext= &pNewBuff[dwIndex + 1];
		}

	pNewBuff[dwIndex].pNext = &pNewBuff[0];

	return pNewBuff;
}

void CBonTuner::FreeIoReqBuff(CBonTuner::AsyncIoReq *pBuff)
{
	if(!pBuff)return;

	// obt@J
	delete [] pBuff;
}

DWORD WINAPI CBonTuner::PushIoThread(LPVOID pParam)
{
	CBonTuner *pThis = (CBonTuner *)pParam;

	DWORD dwLastTime = ::GetTickCount();

//	::OutputDebugString("CBonTuner::PushIoThread() Start!\n");

	// ǉ byMeru(2008/01/22)
	BYTE TxdData[256];
	DWORD dwBufLen;
	CyUSB_IoHeader *pHead = (CyUSB_IoHeader*)TxdData;

	// oN]TCYw
	// {0x81wł͂ȂEndpointDescriptorŎw肳ꂽEndPointݒ肷ׂ
	CyUSB_SetTransferInfo stTransferSize;
	stTransferSize.ucEndpointAddress=0x81;
	stTransferSize.dwTransferSize=TSDATASIZE;
	if(!pThis->SendIoRequest(pThis->m_hDevice,IOCTL_ADAPT_SET_TRANSFER_SIZE,(BYTE*)&stTransferSize,sizeof(CyUSB_SetTransferInfo),(BYTE*)&stTransferSize,sizeof(CyUSB_SetTransferInfo)))
	{
		// ݒ莸s
	}
	
	// NGXg쐬
	// {0x81wł͂ȂEndpointDescriptorŎw肳ꂽEndPointݒ肷ׂ
	dwBufLen=sizeof(CyUSB_IoHeader);
	ZeroMemory(pHead,dwBufLen);
	pHead->ucEndpointAddress=0x81;

	// hCoTSf[^NGXg𔭍s
	while(pThis->m_bLoopIoThread){

		// NGXg҂K薢Ȃǉ
		if(pThis->m_dwBusyReqNum < REQRESERVNUM){

			// hCoTSf[^NGXg𔭍s
			if(!pThis->PushIoRequest(pThis->m_hDevice, IOCTL_ADAPT_SEND_NON_EP0_DIRECT, TxdData, dwBufLen, TSDATASIZE)){
				// G[
				break;
				}

			continue;
			}

		// NGXg҂t̏ꍇ̓EFCg
		::Sleep(REQPOLLINGWAIT);
		}

//	::OutputDebugString("CBonTuner::PushIoThread() End!\n");
	return 0;
}

DWORD WINAPI CBonTuner::PopIoThread(LPVOID pParam)
{
	CBonTuner *pThis = (CBonTuner *)pParam;

	// σNGXg|[OăNGXg
	while(pThis->m_bLoopIoThread){

		// σf[^΃NGXg
		if(pThis->m_dwBusyReqNum){
			
			// NGXg
			if(!pThis->PopIoRequest(pThis->m_hDevice)){
				// G[
				break;
				}
			}
		}

	return 0;
}

const BOOL CBonTuner::PushIoRequest(HANDLE hDevice,const DWORD dwIoCode, BYTE *pTxdData, const DWORD dwTxdSize, const DWORD dwRxdSize)
{
	// hCoɔ񓯊NGXg𔭍s

	// I[v`FbN
	if(hDevice == INVALID_HANDLE_VALUE)return FALSE;

	// NGXgZbg
	m_pIoPushReq->dwIoCode = dwIoCode;
	m_pIoPushReq->dwTxdSize = dwTxdSize;
	m_pIoPushReq->dwRxdSize = 0;
	if(dwTxdSize)::CopyMemory(m_pIoPushReq->TxdBuff, pTxdData, dwTxdSize);

	// Cxgݒ
	::ZeroMemory(&m_pIoPushReq->OverLapped, sizeof(OVERLAPPED));
	if(!(m_pIoPushReq->OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return FALSE;

	// NGXgs
	if(!::DeviceIoControl(hDevice, dwIoCode, m_pIoPushReq->TxdBuff, dwTxdSize, m_pIoPushReq->RxdBuff, dwRxdSize, &m_pIoPushReq->dwRxdSize, &m_pIoPushReq->OverLapped)){
		if(::GetLastError() != ERROR_IO_PENDING){
			::CloseHandle(m_pIoPushReq->OverLapped.hEvent);
			return FALSE;
			}
		}

	m_pIoPushReq->dwState = IORS_BUSY;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPushReq = m_pIoPushReq->pNext;
	m_dwBusyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	return TRUE;
}

const BOOL CBonTuner::PopIoRequest(HANDLE hDevice)
{
	// 񓯊NGXg
	
	// I[v`FbN
	if(hDevice == INVALID_HANDLE_VALUE)return FALSE;
	
	// ԃ`FbN
	if(m_pIoPopReq->dwState != IORS_BUSY){
		// O
		return TRUE;
		}

	// NGXg擾
	const BOOL bRet = ::GetOverlappedResult(hDevice, &m_pIoPopReq->OverLapped, &m_pIoPopReq->dwRxdSize, FALSE);

	// G[`FbN
	if(!bRet){
		if(::GetLastError() == ERROR_IO_INCOMPLETE){
			// 
			::Sleep(REQPOLLINGWAIT);
			return TRUE;
			}
		}

	// Cxg폜
	::CloseHandle(m_pIoPopReq->OverLapped.hEvent);

	if(!bRet){
		// G[
		return FALSE;
		}

	m_pIoPopReq->dwState = IORS_RECV;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPopReq = m_pIoPopReq->pNext;
	m_dwBusyReqNum--;
	m_dwReadyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	// CxgZbg
	::SetEvent(m_hOnStreamEvent);

	return TRUE;
}

