// BonTuner.h: CBonTuner NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_BONTUNER_H_)
#define _BONTUNER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "IBonDriver2.h"
#include "USBIO.h"

#define BONTYPE_UNKNOWN		0x00	// s
#define BONTYPE_WHITE		0x01	// (ISDB-T)
#define BONTYPE_BLACK		0x02	// (ISDB-S)
#define BONTYPE_RED			0x03	// (ISDB-T/ISDB-SôIH)
#define BONTYPE_GRAY		0x01	// D(RĊDɂȂƂȂȂƂIH)

class CBonTuner : public IBonDriver2
{
public:
	CBonTuner();
	virtual ~CBonTuner();

// IBonDriver
	const BOOL OpenTuner(void);
	void CloseTuner(void);

	const BOOL SetChannel(const BYTE bCh);
	const float GetSignalLevel(void);

	const DWORD WaitTsStream(const DWORD dwTimeOut = 0);
	const DWORD GetReadyCount(void);

	const BOOL GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain);
	const BOOL GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain);

	void PurgeTsStream(void);

// IBonDriver2(b)
	LPCTSTR GetTunerName(void);

	const BOOL IsTunerOpening(void);
	
	LPCTSTR EnumTuningSpace(const DWORD dwSpace);
	LPCTSTR EnumChannelName(const DWORD dwSpace, const DWORD dwChannel);

	const BOOL SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	
	const DWORD GetCurSpace(void);
	const DWORD GetCurChannel(void);

	void Release(void);

	static CBonTuner * m_pThis;
	static HINSTANCE m_hModule;

protected:
	// I/ONGXgL[f[^
	struct AsyncIoReq
	{
		OVERLAPPED OverLapped;
		DWORD dwState;
		DWORD dwIoCode;
		DWORD dwTxdSize;
		DWORD dwRxdSize;
		BYTE TxdBuff[64];
		BYTE RxdBuff[48128];
		AsyncIoReq *pNext;
	};

	const HANDLE FindFriioDriver(const BOOL bSatellite = FALSE,const BYTE byDeviceIndex = 0);
	static const BOOL GetDriverPath(GUID *pGuid, LPTSTR lpszPath, const DWORD dwDeviceIndex = 0UL);

	const int SendIoRequest(HANDLE hDevice,const DWORD dwIoCode, const BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize);

	AsyncIoReq * AllocIoReqBuff(const DWORD dwBuffNum);
	void FreeIoReqBuff(AsyncIoReq *pBuff);

	static DWORD WINAPI PushIoThread(LPVOID pParam);
	static DWORD WINAPI PopIoThread(LPVOID pParam);

	const BOOL PushIoRequest(HANDLE hDevice,const DWORD dwIoCode, BYTE *pTxdData, const DWORD dwTxdSize, const DWORD dwRxdSize);
	const BOOL PopIoRequest(HANDLE hDevice);

	HANDLE m_hMutex;

	HANDLE m_hDevice;		/* FriioView1.81 ȍ~̓nhPɂȂ */
	BYTE m_TxdBuff[256];
	BYTE m_RxdBuff[256];

	AsyncIoReq *m_pIoReqBuff;
	AsyncIoReq *m_pIoPushReq;
	AsyncIoReq *m_pIoPopReq;
	AsyncIoReq *m_pIoGetReq;

	DWORD m_dwBusyReqNum;
	DWORD m_dwReadyReqNum;

	HANDLE m_hPushIoThread;
	HANDLE m_hPopIoThread;
	BOOL m_bLoopIoThread;

	HANDLE m_hOnStreamEvent;

	CRITICAL_SECTION m_CriticalSection;
	
	DWORD m_dwCurSpace;
	DWORD m_dwCurChannel;

	// ǉ byMeru(2008/01/22)
	// ύX byMeru(2008/04/22) 1.81Ή
	inline CyUSB_IoHeader* MakeRequestHeader(CyUSB_IoHeader* lpstIoHead,UCHAR ucReqType,UCHAR ucReqNo,WORD wValue,WORD wIndex,WORD wLength,
								   DWORD dwTimeout=CYUSB_DEFAULT_TIMEOUT,UCHAR ucEndpointAddress=0x00,DWORD dwBufferLength=0);
	const BOOL UsbInitalize(HANDLE hDevice,int *piBonType=NULL);
	const BOOL UsbTerminate(HANDLE hDevice);

	const BOOL UsbGetStringDescriptor(HANDLE hDevice,UCHAR ucIndex,WORD wLocale,UCHAR *pBuffer,WORD wBufSize);
	const BOOL UsbProcDescriptor(HANDLE hDevice,BOOL bForceOpen=FALSE);
	const BOOL UsbProcBegin(HANDLE hDevice);
	const BOOL UsbProcEnd(HANDLE hDevice);
	const BOOL UsbProcFixInitA(HANDLE hDevice,int *piBonType=NULL);
	const BOOL UsbProcFixInitB(HANDLE hDevice);
	const BOOL UsbProcLED(HANDLE hDevice,const BYTE bType);
	const BOOL UsbProcStreamInit(HANDLE hDevice);
	const BOOL UsbSendVendorRequest(HANDLE hDevice,WORD wValue,WORD wIndex);

	// ΉAPI
	const BOOL UsbProcLED_White(HANDLE hDevice,const BYTE bType);
	const BOOL UsbProcLED_Black(HANDLE hDevice,const BYTE bType);
	const float GetSignalLevel_White(void);
	const float GetSignalLevel_Black(void);
	const BOOL SetChannel_White(const DWORD dwSpace, const DWORD dwChannel);
	const BOOL SetChannel_Black(const DWORD dwSpace, const DWORD dwChannel);

	int m_iBonType;
};

#endif // !defined(_BONTUNER_H_)
