#include <windows.h>
#include <Malloc.h>
#include <InitGuid.h>
#include <SetupApi.h>
#include "UsbIo.h"

#pragma comment(lib, "SetupApi.lib")

#define FRIIO_UNKNOWN	0
#define FRIIO_WHITE		1
#define FRIIO_BLACK		2

// hCoCX^XGUID
DEFINE_GUID( GUID_FRIIO_DRIVER,	0x5a56d255L, 0xe23a, 0x4b4d, 0x8c, 0x78, 0xc2, 0x65, 0x93, 0x0b, 0x6c, 0x68 );

#define DESCRIPTOR_BUFFER_SIZE 1024

const BOOL GetDriverPath(GUID *pGuid, LPSTR lpszPath)
{
	// GUIDfoCX̃pX擾

	// foCXZbg̃nh擾
	HDEVINFO hDevInfo = SetupDiGetClassDevs(pGuid, 0, NULL, DIGCF_PRESENT | DIGCF_INTERFACEDEVICE);
	if(hDevInfo == INVALID_HANDLE_VALUE)return FALSE;

	// foCXC^tF[X
	SP_DEVICE_INTERFACE_DATA DeviceInterfaceData;
	DeviceInterfaceData.cbSize = sizeof(DeviceInterfaceData);
	if(!SetupDiEnumDeviceInterfaces( hDevInfo, NULL, pGuid, 0, &DeviceInterfaceData)){
		SetupDiDestroyDeviceInfoList(hDevInfo);
		return FALSE;
		}

	// foCXC^tF[X̏ڍׂi[̂ɕKvȃobt@TCY擾
	DWORD dwBuffLen = 0;
	SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, NULL, 0, &dwBuffLen, NULL);

	// obt@m
	dwBuffLen += sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA) + 1;
	SP_DEVICE_INTERFACE_DETAIL_DATA *pDeviceInterfaceDetailData = (SP_DEVICE_INTERFACE_DETAIL_DATA *)_alloca(dwBuffLen);
	pDeviceInterfaceDetailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

	// foCX̃pX擾
	if(!SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, pDeviceInterfaceDetailData, dwBuffLen, NULL, NULL)){
		SetupDiDestroyDeviceInfoList(hDevInfo);
		return FALSE;
		}

	// foCXZbg̃nhJ
	SetupDiDestroyDeviceInfoList(hDevInfo);

	// foCX̃pXRs[
	lstrcpy(lpszPath, pDeviceInterfaceDetailData->DevicePath);

	return TRUE;
}

// WRg[]NGXgwb_̍쐬
// @Xe[^X=0 IsoPacket=Ȃ̑O(ȂƂ}ɂ͂Ȃ)
// @̃wb_̒datapobt@B malloc( sizeof(CyUSB_IoHeader) + dwBufferLength ); Kv
//   (AWNGXgEP0ɑꍇAEzUSBFX2LPEP0obt@̂64oCgȂ̂ŁAȏ͕KvȂ)
CyUSB_IoHeader* MakeRequestHeader(CyUSB_IoHeader* lpstIoHead,UCHAR ucReqType,UCHAR ucReqNo,WORD wValue,WORD wIndex,WORD wLength,
								   DWORD dwTimeout,UCHAR ucEndpointAddress,DWORD dwBufferLength)
{
	if(!lpstIoHead) return NULL;
	ZeroMemory(lpstIoHead,sizeof(CyUSB_IoHeader)+dwBufferLength);

	lpstIoHead->ucRequestType = ucReqType;
	lpstIoHead->ucRequestNo = ucReqNo;
	lpstIoHead->wValue = wValue;
	lpstIoHead->wIndex = wIndex;
	lpstIoHead->wLength = wLength;
	lpstIoHead->dwTimeout = dwTimeout;
	lpstIoHead->ucEndpointAddress = ucEndpointAddress;

	// obt@ȂꍇłItZbgl
	lpstIoHead->dwBufferOffset= sizeof(CyUSB_IoHeader);
	lpstIoHead->dwBufferLength = dwBufferLength;

	return lpstIoHead;
}

const int SendIoRequest(const HANDLE hDeivce, const DWORD dwIoCode, BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize)
{
	// I[v`FbN
	if(hDeivce == INVALID_HANDLE_VALUE)return -1;

	// Mpf[^ݒ
	OVERLAPPED OverLapped;
	::ZeroMemory(&OverLapped, sizeof(OverLapped));
	if(!(OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return -1;

	// f[^M
	DWORD dwReturned = 0;
	const BOOL bRet = ::DeviceIoControl(hDeivce, dwIoCode, pTxdData, dwTxdSize, pRxdData, dwRxdSize, &dwReturned, &OverLapped);
	
	// Cxg폜
	::CloseHandle(OverLapped.hEvent);

	// G[AMf[^擾
	if(!bRet){
		if(::GetLastError() != ERROR_IO_PENDING)return -1;
		if(!::GetOverlappedResult(hDeivce, &OverLapped, &dwReturned, TRUE))return -1;
		}

	return (int)dwReturned;
}

// StringDescriptor擾
//   ʂ߂Ȃ̂UsbProcDescriptor番(2008/01/21)
const BOOL UsbGetStringDescriptor(const HANDLE hDevice,UCHAR ucIndex,WORD wLocale,UCHAR *pBuffer,WORD wBufSize)
{
	CyUSB_IoHeader *pHead = (CyUSB_IoHeader*)pBuffer;
	unsigned char *pData=(unsigned char*)(pBuffer+sizeof(CyUSB_IoHeader));
	unsigned char ucReqType=REQTYPE_TO_HOST|REQTYPE_STANDARD;
	DWORD dwCtrl=IOCTL_ADAPT_SEND_EP0_CONTROL_TRANSFER;
	int iRetByte;
	WORD wBufLen;

	CyUSB_DescriptorHeader *lpDescriptorHead=NULL;

	// v쐬
	wBufLen=0x02;
	MakeRequestHeader(pHead,ucReqType,0x06,0x0300,wLocale,wBufLen,CYUSB_DEFAULT_TIMEOUT,0x00,wBufLen);
	pHead->wValue |= ucIndex;
	lpDescriptorHead=(CyUSB_DescriptorHeader*)pData;
	wBufLen+=sizeof(CyUSB_IoHeader);
	// PڂŃobt@炤
	iRetByte=SendIoRequest(hDevice,dwCtrl,(BYTE*)pHead,wBufLen,(BYTE*)pHead,wBufLen);
	if(iRetByte==-1) return FALSE;
	// QڂŃf[^擾
	wBufLen=lpDescriptorHead->ucDescriptorLength;
	MakeRequestHeader(pHead,ucReqType,0x06,0x0300,wLocale,wBufLen,CYUSB_DEFAULT_TIMEOUT,0x00,wBufLen);
	pHead->wValue |= ucIndex;
	wBufLen+=sizeof(CyUSB_IoHeader);
	iRetByte=SendIoRequest(hDevice,dwCtrl,(BYTE*)pHead,wBufLen,(BYTE*)pHead,wBufLen);
	if(iRetByte==-1) return FALSE;
	return TRUE;
}

// fXNv^
//   BOOL bForceOpen=TRUEAIO͕KƌȂ(G[)
//   EP0փfoCXǂݍ݂ɍs
//   Descriptor̓e`FbN͂ĂȂǁA{̓`FbNďׂ
//
// ⑫ bymeru(2008/01/21)
//   nProtect(nbNh~)Ǝsꍇ
//   ̏ꍇAbForceOpen=TRUEɂď蒼(Ǎ͖̔鎖)
const BOOL UsbProcDescriptor(const HANDLE hDevice,BOOL bForceOpen)
{
	int iError=0;
	unsigned char ucBuffer[DESCRIPTOR_BUFFER_SIZE];
	CyUSB_IoHeader *pHead = (CyUSB_IoHeader*)ucBuffer;
	unsigned char *pData=(unsigned char*)(ucBuffer+sizeof(CyUSB_IoHeader));
	unsigned char ucReqType=REQTYPE_TO_HOST|REQTYPE_STANDARD;
	DWORD dwCtrl=IOCTL_ADAPT_SEND_EP0_CONTROL_TRANSFER;
	DWORD dwRetByte;
	WORD wBufLen;
	WORD wLocale;
	BOOL bRet;

	CyUSB_DescriptorHeader *lpDescriptorHead=NULL;
	
	try
	{
		// Descriptor
		struct CyUSB_DeviceDescriptor stDevice;
		struct CyUSB_ConfigurationDescriptor stConfig;

		// DeviceDescriptor擾
		wBufLen=sizeof(CyUSB_DeviceDescriptor);
		MakeRequestHeader(pHead,ucReqType,0x06,0x0100,0x0000,wBufLen,CYUSB_DEFAULT_TIMEOUT,0x00,wBufLen);
		CyUSB_DeviceDescriptor *lpDeviceDescriptor=(CyUSB_DeviceDescriptor*)pData;
		wBufLen+=sizeof(CyUSB_IoHeader);
		dwRetByte=SendIoRequest(hDevice,dwCtrl,(BYTE*)pHead,wBufLen,(BYTE*)pHead,wBufLen);
		if(!bForceOpen&&dwRetByte==-1) throw 1;
		memcpy(&stDevice,lpDeviceDescriptor,sizeof(CyUSB_DeviceDescriptor));		

		// StringDescriptorR[hP[擾?
		//   擾l=0x0409 : čpꃍP[?
		bRet=UsbGetStringDescriptor(hDevice,0,0x00,ucBuffer,DESCRIPTOR_BUFFER_SIZE);
		if(!bForceOpen&&!bRet) throw 2;
		memcpy(&wLocale,pData+2,sizeof(WORD));
	
		// DeviceDescriptor̎̕擾(Unicode,I[Ȃ)
		// =L"774" (ȂȂIH)
		bRet=UsbGetStringDescriptor(hDevice,stDevice.ucManufacturer,wLocale,ucBuffer,DESCRIPTOR_BUFFER_SIZE);
		if(!bForceOpen&&!bRet) throw 3;
		// i=L"Friio USB 2.0 Digital TV Reciever"
		bRet=UsbGetStringDescriptor(hDevice,stDevice.ucProduct,wLocale,ucBuffer,DESCRIPTOR_BUFFER_SIZE);
		if(!bForceOpen&&!bRet) throw 4;

		// StringDescriptorR[hP[擾?
		//   擾l=0x0409 : čpꃍP[?
		//   Ď擾Ă邯ǁAȂC
		bRet=UsbGetStringDescriptor(hDevice,0,wLocale,ucBuffer,DESCRIPTOR_BUFFER_SIZE);
		if(!bForceOpen&&!bRet) throw 5;		

		// foCX̃AhX擾
		//   CypressTvInBufferɂ͒lZbgĂȂǁH
		//   ߂l͊ˑH
		wBufLen=1;
		ucBuffer[0]=0xAD;
		dwRetByte=SendIoRequest(hDevice,IOCTL_ADAPT_GET_ADDRESS,ucBuffer,wBufLen,ucBuffer,wBufLen);
		if(!bForceOpen&&dwRetByte==-1) throw 6;

		// foCXv(ASCII,I[Ȃ?)
		//   foCX=0000.001d.0007.001.003.000.000.000.000
		//   ߂l͊ˑ
		wBufLen=0x100;
		ZeroMemory(&ucBuffer,wBufLen);
		dwRetByte=SendIoRequest(hDevice,IOCTL_ADAPT_GET_DEVICE_NAME,ucBuffer,wBufLen,ucBuffer,wBufLen);		
		if(!bForceOpen&&dwRetByte==-1) throw 7;

		// thv(ASCII,I[Ȃ?)
		//   th=Friio USB 2.0 Digital TV Receiver
		wBufLen=0x100;
		ZeroMemory(&ucBuffer,wBufLen);
		dwRetByte=SendIoRequest(hDevice,IOCTL_ADAPT_GET_FRIENDLY_NAME,ucBuffer,wBufLen,ucBuffer,wBufLen);
		if(!bForceOpen&&dwRetByte==-1) throw 8;

		// hCoo[W擾
		//   o[W=1.8.120
		wBufLen=4;
		ZeroMemory(&ucBuffer,wBufLen);
		ucBuffer[0]=0x0D;
		ucBuffer[1]=0xF0;
		ucBuffer[2]=0xAD;
		ucBuffer[3]=0xBA;
		dwRetByte=SendIoRequest(hDevice,IOCTL_ADAPT_GET_DRIVER_VERSION,ucBuffer,wBufLen,ucBuffer,wBufLen);
		if(!bForceOpen&&dwRetByte==-1) throw 9;


		// USBDIo[W擾
		//   o[W=00 60 00 00
		wBufLen=4;
		ZeroMemory(&ucBuffer,wBufLen);
		ucBuffer[0]=0x0D;
		ucBuffer[1]=0xF0;
		ucBuffer[2]=0xAD;
		ucBuffer[3]=0xBA;
		dwRetByte=SendIoRequest(hDevice,IOCTL_ADAPT_GET_USBDI_VERSION,ucBuffer,wBufLen,ucBuffer,wBufLen);
		if(!bForceOpen&&dwRetByte==-1) throw 10;

		// foCXx擾擾
		//   x=2=HighSpeedMode(tKidȂHighSpeed>FullSpeedĂ͕̂킵)
		//   zXg̊֌Wőx=1ɂȂ̂ł΃G[ɂق
		wBufLen=4;
		ZeroMemory(&ucBuffer,wBufLen);
		dwRetByte=SendIoRequest(hDevice,IOCTL_ADAPT_GET_DEVICE_SPEED,ucBuffer,wBufLen,ucBuffer,wBufLen);
		if(!bForceOpen&&dwRetByte==-1) throw 10;
		

		// ConfigurationDescriptor擾
		wBufLen=sizeof(CyUSB_ConfigurationDescriptor);
		MakeRequestHeader(pHead,ucReqType,0x06,0x0200,0x0000,wBufLen,CYUSB_DEFAULT_TIMEOUT,0x00,wBufLen);
		CyUSB_ConfigurationDescriptor *lpConfigurationDescriptor=(CyUSB_ConfigurationDescriptor*)pData;
		wBufLen+=sizeof(CyUSB_IoHeader);
		dwRetByte=SendIoRequest(hDevice,dwCtrl,(BYTE*)pHead,wBufLen,(BYTE*)pHead,wBufLen);
		if(!bForceOpen&&dwRetByte==-1) throw 11;
		memcpy(&stConfig,lpConfigurationDescriptor,sizeof(CyUSB_ConfigurationDescriptor));

		// ConfigurationDescriptorɑInterfaceDescriptor,EndpointDescriptor擾
		//   AltInterface悭킩Ȃ̂ŁAƉ
		wBufLen=stConfig.wTotalLength;
		MakeRequestHeader(pHead,ucReqType,0x06,0x0200,0x0000,wBufLen,CYUSB_DEFAULT_TIMEOUT,0x00,wBufLen);
		wBufLen+=sizeof(CyUSB_IoHeader);
		dwRetByte=SendIoRequest(hDevice,dwCtrl,(BYTE*)pHead,wBufLen,(BYTE*)pHead,wBufLen);
		if(!bForceOpen&&dwRetByte==-1) throw 12;
		// f[^ߑłɂ邩Awhileł܂킵Headerf邩EEEǂ
		for(int iInterface=0,pos=0;iInterface<stConfig.ucNumInterface;iInterface++)
		{
			// InterfaceDescriptor
			CyUSB_DescriptorHeader *lpDescHdr=(CyUSB_DescriptorHeader*)&ucBuffer[pHead->dwBufferOffset+sizeof(CyUSB_ConfigurationDescriptor)+pos];
			if(lpDescHdr->ucDescriptorType!=0x04||lpDescHdr->ucDescriptorLength!=0x09) throw 13;
			CyUSB_InterfaceDescriptor *lpInterfaceDescriptor=(CyUSB_InterfaceDescriptor*)lpDescHdr;
			pos+=lpDescHdr->ucDescriptorLength;
			// EndpointDescriptor
			for(int iEndpoint=0;iEndpoint<lpInterfaceDescriptor->ucNumEndpoints;iEndpoint++)
			{
				lpDescHdr=(CyUSB_DescriptorHeader*)&ucBuffer[pHead->dwBufferOffset+sizeof(CyUSB_ConfigurationDescriptor)+pos];
				if(lpDescHdr->ucDescriptorType!=0x05||lpDescHdr->ucDescriptorLength!=0x07) throw 14;
				CyUSB_EndpointDescriptor *lpEndpointDescriptor=(CyUSB_EndpointDescriptor*)lpDescHdr;
				pos+=lpDescHdr->ucDescriptorLength;
			}
			// InterfaceDescriptor(Alternate)
			lpDescHdr=(CyUSB_DescriptorHeader*)&ucBuffer[pHead->dwBufferOffset+sizeof(CyUSB_ConfigurationDescriptor)+pos];
			if(lpDescHdr->ucDescriptorType!=0x04||lpDescHdr->ucDescriptorLength!=0x09) throw 15;
			CyUSB_InterfaceDescriptor *lpInterfaceDescriptorALT=(CyUSB_InterfaceDescriptor*)lpDescHdr;
			pos+=lpDescHdr->ucDescriptorLength;
			// EndpointDescriptor(Alternate)
			for(int iEndpoint=0;iEndpoint<lpInterfaceDescriptorALT->ucNumEndpoints;iEndpoint++)
			{
				lpDescHdr=(CyUSB_DescriptorHeader*)&ucBuffer[pHead->dwBufferOffset+sizeof(CyUSB_ConfigurationDescriptor)+pos];
				if(lpDescHdr->ucDescriptorType!=0x05||lpDescHdr->ucDescriptorLength!=0x07) throw 16;
				CyUSB_EndpointDescriptor *lpEndpointDescriptor=(CyUSB_EndpointDescriptor*)lpDescHdr;
				pos+=lpDescHdr->ucDescriptorLength;
			}
		}

		// IOCTL_ADAPT_GET_ALT_INTERFACE_SETTING擾
		//   悭킩ȂEEE
		wBufLen=1;
		ucBuffer[0]=0x01;
		dwRetByte=SendIoRequest(hDevice,IOCTL_ADAPT_GET_ALT_INTERFACE_SETTING,ucBuffer,wBufLen,ucBuffer,wBufLen);
		if(!bForceOpen&&dwRetByte==-1) throw 17;
	} catch(int err)
	{
		// SetLastError()ŃG[ZbgƂ(G[ԍBit29𗧂Ă)
		iError=err;
	}
	return iError==0;
}


// Request=0x40 RequestNo=0x01  Length=0 ̃x_NGXg𑗐M
const BOOL UsbSendVendorRequest(const HANDLE hDevice,WORD wValue,WORD wIndex)
{
	unsigned char ucBuffer[DESCRIPTOR_BUFFER_SIZE];
	CyUSB_IoHeader *pHead = (CyUSB_IoHeader*)ucBuffer;
	DWORD dwSize=sizeof(CyUSB_IoHeader);
	
	MakeRequestHeader(pHead,REQTYPE_TO_DEVICE|REQTYPE_VENDOR,0x01,wValue,wIndex,0,CYUSB_VENDOR_TIMEOUT,0,0);
	return (SendIoRequest(hDevice,IOCTL_ADAPT_SEND_EP0_CONTROL_TRANSFER,ucBuffer,dwSize,ucBuffer,dwSize)!=-1);
}


// Œ菈`
const int UsbProcFixInitA(const HANDLE hDevice)
{
	int iRet = FRIIO_UNKNOWN;
	BYTE TxdData[256],RxdData[256];
	DWORD dwBufLen;
	CyUSB_IoHeader *pHead = (CyUSB_IoHeader*)TxdData;
	BYTE *pData=(BYTE*)(TxdData+sizeof(CyUSB_IoHeader));
	BYTE *pRet=(BYTE*)(RxdData+sizeof(CyUSB_IoHeader));

	// 1
	UsbSendVendorRequest(hDevice,0x0002,0x0011);
	// 2
	UsbSendVendorRequest(hDevice,0x0000,0x0011);

	// 3
	dwBufLen=sizeof(CyUSB_IoHeader)+1;	
	MakeRequestHeader(pHead,REQTYPE_TO_DEVICE|REQTYPE_VENDOR,0x03,0x3000,0x00FE,0x0001,CYUSB_VENDOR_TIMEOUT,0,0x0001);
	pData[0]=0xC1;
	if(SendIoRequest(hDevice, IOCTL_ADAPT_SEND_EP0_CONTROL_TRANSFER, TxdData, dwBufLen, RxdData, dwBufLen) == -1)return FRIIO_UNKNOWN;

	// 4
	MakeRequestHeader(pHead,REQTYPE_TO_HOST|REQTYPE_VENDOR,0x02,0x3000,0x0100,0x0001,CYUSB_VENDOR_TIMEOUT,0,0x0001);
	if(SendIoRequest(hDevice, IOCTL_ADAPT_SEND_EP0_CONTROL_TRANSFER, TxdData, dwBufLen, RxdData, dwBufLen) == -1)return FRIIO_UNKNOWN;
	if(pRet[0]){
		// }
		iRet = FRIIO_WHITE;
		} else {
		// }
		// 4'
		iRet = FRIIO_BLACK;
		MakeRequestHeader(pHead,REQTYPE_TO_HOST|REQTYPE_VENDOR,0x02,0x3000,0x0080,0x0001,CYUSB_VENDOR_TIMEOUT,0,0x0001);
		if(SendIoRequest(hDevice, IOCTL_ADAPT_SEND_EP0_CONTROL_TRANSFER, TxdData, dwBufLen, RxdData, dwBufLen) == -1)return FRIIO_UNKNOWN;
		}
	// 5
	UsbSendVendorRequest(hDevice,0x0004,0x0030);
	return iRet;
}

// USB
const BOOL UsbInitalize(const HANDLE hDevice,int *piFriioType)
{
	int iError=0;
	unsigned char ucBuffer[DESCRIPTOR_BUFFER_SIZE];
	CyUSB_IoHeader *pHead = (CyUSB_IoHeader*)ucBuffer;
	unsigned char *pData=(unsigned char*)(ucBuffer+sizeof(CyUSB_IoHeader));
	unsigned char ucReqType=REQTYPE_TO_HOST|REQTYPE_STANDARD;
	DWORD dwCtrl=IOCTL_ADAPT_SEND_EP0_CONTROL_TRANSFER;
	BOOL bRet;

	CyUSB_DescriptorHeader *lpDescriptorHead=NULL;
	
	try
	{
		// Rg[fXNv^擾
		bRet=UsbProcDescriptor(hDevice,FALSE);
		if(!bRet)
		{
			// nProtect̂悤Ȉꕔ̃\tgEFAŃfXNv^̎擾jQꍇ
			// ǂ߂Ȃڂ͖
			bRet=UsbProcDescriptor(hDevice,TRUE);
		}
		if(!bRet) throw 1;
		// Œ菈`
		int iFriioType=UsbProcFixInitA(hDevice);
		if(iFriioType==FRIIO_UNKNOWN) throw 2;

		*piFriioType = iFriioType;

		// _(OoO)^l
	} catch(int err)
	{
		// SetLastError()ŃG[ZbgƂ(G[ԍBit29𗧂Ă)
		iError=err;
	}
	/*
	if(iError)
	{
		char buf[80];
		wsprintf(buf,"errcode=%d",iError);
		MessageBox(NULL,buf,"UsbInit()",MB_OK);
	}
	*/
	return iError==0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{

	// hCoCX^X擾
	char szDeviceName[_MAX_PATH];

	// 64bit\tgEFA
	BOOL b64Bit = sizeof(int*) > 4 ? TRUE : FALSE;

	LPSTR lpszAppName = !b64Bit ? "BonChecker" : "BonChecker(x64)";

	HANDLE hDevice = INVALID_HANDLE_VALUE;
	try {
		if(!GetDriverPath((GUID *)&GUID_FRIIO_DRIVER, szDeviceName)){
			throw "Friio𔭌ł܂ł";
			}

		HANDLE hDevice = ::CreateFile(szDeviceName, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL);
		if(hDevice==INVALID_HANDLE_VALUE){
			throw "foCXɐڑł܂ł.";
			}

		int iFriioType;
		if(!UsbInitalize(hDevice,&iFriioType)){
			throw "Ɏs܂.";
			}

		LPSTR pFriio = "Unknown Friio";
		char szBuf[_MAX_PATH+80];
		switch(iFriioType){
			case FRIIO_WHITE:
				wsprintf(szBuf,"%s\n\nFriio(ISDB-T)",szDeviceName);
				break;
			case FRIIO_BLACK:
				wsprintf(szBuf,"%s\n\nFriio(ISDB-S)",szDeviceName);
				break;
			default:
				wsprintf(szBuf,"%s\nHFriio",szDeviceName);
			}
			MessageBox(NULL,szBuf,lpszAppName,MB_OK);
		} catch( LPCSTR lpszErrMsg ) {			
			MessageBox(NULL,lpszErrMsg,lpszAppName,MB_OK);
		}
	if(hDevice!=INVALID_HANDLE_VALUE) CloseHandle(hDevice);

	return 0;
}